import es
import gamethread
import playerlib
import shelve
import random
import popuplib
import time
import string
import psyco
from xpints import *

info = es.AddonInfo()
info.name = '10 Pints Zombie Mod - Environment'
info.version = '1.1.24'
info.basename = '10pintsEnvironment'
info.url = 'www.thefactoidvoid.com'
info.author = 'Largo Usagi'



psyco.full()
'''
It Will allways be assumed that CT's are Zombies and T's are Humans
'''

################################################################################
#						 													  #
#						      Environment Globals                             #
#																			  #
################################################################################
environmentVars = {'rounds':1, 'fails':5,'mapName':'0','special':0,'special1':0,'special2':0}
player = xpints.player()

################################################################################
#						 													  #
#							        CSS Events                                #
#																			  #
################################################################################
def load():
	global env
	env = environment()
	gamethread.delayed(1,es.server.queuecmd,'exec xpints.cfg')
	if not es.exists('saycommand', '1x01337XS2'):
		es.regsaycmd('1x01337XS2', 'xpints/environment/forceNightMission')
	
def unload():
	doshit = 1
	
def round_start(ev):
	env.mapSetup().checkMode(ev)
	env.roundSetup().roundSetup(ev)
	env.setBotCount()
	
def player_hurt(ev):
	env.hurt(ev)
	
def es_map_start(ev):
	random.seed()
	random.jumpahead(random.randint(0,9999))
	env.mapSetup().getMapName(ev)
	env.roundSetup().newMap()
	gamethread.delayed(1,es.server.queuecmd,'exec xpints.cfg')

def round_end(ev):
	env.roundSetup().newRound(ev)
	
def player_spawn(ev):
	env.spawn(ev)
	env.setBotCount()
	
################################################################################
#						 													  #
#					 	      Global Commands                                 #
#																			  #
################################################################################

def forceNightMission():
	environmentVars['special'] = 1
	environmentVars['special1'] = 1
	es.dbgmsg(0,'Forcing Night Mission')

def getSteamid(userid):
	userid = int(userid)
	steamid = playerlib.uniqueid(userid, True)
	if 'bot' in steamid:
		steamid = es.getplayername(userid)
	return steamid
	
################################################################################
#						 													  #
#					 	    Environment Class                                 #
#																			  #
################################################################################



class environment:
	def __init__(self):
		pass
		
	def getRoundNum(self):
		return environmentVars['rounds']
				
	def setBotCount(self):
		list = playerlib.getPlayerList('#t')
		playerCount = 0
		for player in list:
			playerCount += 1
			
		if playerCount == 6:
			bots = 1 + ( 4 * playerCount )
		elif playerCount == 1:
			bots = 5 + ( 5 * playerCount )
		else:
			bots = 2 + ( 5 * playerCount ) + playerCount
		es.server.queuecmd('bot_quota %s' %bots)
		
	def hurt(self,ev):
		#usermsg.hudhint(ev['userid'], 'Health: ' + ev['health'])
		doshit = 1
		
	def spawn(self,ev):
		team = ev['es_userteam']
		userid = ev['userid']
		if team == '3':
			hp = 75 + (10 * environmentVars['rounds'] )
			player.addHealth(ev['userid'], hp)
			
	class specialMission:
		def __init__(self):
			pass
			
		def nightMission(self):
			es.lightstyle(0,'b')
			es.dbgmsg(0,'Starting Night Mission')
			
		def doubledUp(self):
			doshit = 1
			
		def round11(self):
			doshit = 1
			
	class roundSetup:
		def __init__(self):
			pass
			
		def roundSetup(self,ev):
			if environmentVars['special'] == 0:
				if environmentVars['fails'] >= 0:
					time = environmentVars['rounds']
					if time > 9:
						time = 9
					if environmentVars['rounds'] == 10:
						environmentVars['fails'] = 0
						es.msg("#multi", "#greenFINAL ROUND, Can you turn it up to 11?")
					if environmentVars['rounds'] == 11:
						es.msg("#multi", "#greenRound 11...")
						#doshti for round 11
						
					es.msg("#multi", "#greenYou are now on round " + str(environmentVars['rounds']) + " and have to survive " + str(time) + " minutes")
				else:
					es.server.queuecmd('mp_roundtime 9')
					es.server.queuecmd('mp_freezetime 60')
					maps = ('xp_italy','xp_dust','xp_dust2')
					es.msg("#multi", "#greenStarting Map Vote" )
					gamethread.delayed(10,es.server.queuecmd,('changelevel ' + random.choice(maps))) #temp fix for map problem
					list = playerlib.getPlayerList('#all')
					for players in list:
						player.setSpeed(players.userid, .0000000000000000001)
			else:
				if environmentVars['special'] == 1:
					es.msg("#multi", "#greenStarting Night Mission")
					environment().specialMission().nightMission()
				else:
					es.dbgmsg(0,'Special Mission Not Found Starting Normal Round')
					environmentVars['special'] = 0
					self.roundSetup(ev)
				environmentVars['special'] = 0
				environmentVars['special1'] = 1
				
			userid = es.getuserid()
			if userid:
				es.server.queuecmd('es_fire %s game_weapon_manager addoutput "maxpieces 0"' % userid)
			
			
		def newRound(self,ev):
			if environmentVars['special'] == 0:
				es.lightstyle(0,'g')
				if ev['winner'] == '2':
					es.centermsg('Humans Win')
					environmentVars['rounds'] += 1
					time = environmentVars['rounds']
					
					if environmentVars['rounds'] == 5 and environmentVars['special1'] == 0:
						chance = random.randint(1,100)
						if chance >= 70:
							#special = (1,1)
							#environmentVars['special'] = random.choice(special)
							#environmentVars['special1'] = 1
							reservedforspecialcode = 1
							
					es.server.queuecmd('mp_roundtime %s' %time)
					if environmentVars['rounds'] == 11:
						doshitforlinkingtoround11epicmode = 0
				if ev['winner'] == '3':
					list = playerlib.getPlayerList('#t')
					playerCount = 0
					es.centermsg( 'Zombies Win')
					for player in list:
						playerCount += 1
					if playerCount > 0:
						environmentVars['fails'] -= 1
						if environmentVars['fails'] == -1:
							es.msg("#multi", "#green----GAME OVER----" )
							es.msg("#multi", "#green----GAME OVER----" )
							es.msg("#multi", "#green----GAME OVER----" )
							es.msg("#multi", "#green----GAME OVER----" )
							es.msg("#multi", "#green----GAME OVER----" )
							es.server.queuecmd('mp_roundtime 9')
							es.server.queuecmd('mp_freezetime 60')
							for userid in es.getUseridList():
								player.setSpeed(userid, .0000000000000000001)
					es.msg("#multi", "#greenHumans Failed to Pass round " + str(environmentVars['rounds']) + " and have " + str(environmentVars['fails']) + " Retrys remaining" )
			else:
				if environmentVars['special'] == 1:
					if ev['winner'] == '2':
						es.msg("#multi", "#greenHumans Survived the Night Mission")
					if ev['winner'] == '3':
						es.msg("#multi", "#greenZombies Slaughterd The Humans in the Night")
				else:
					es.dbgmsg(0,'Special Mission Not Found Starting Normal Round')
		
		def newMap(self):
			environmentVars['rounds'] = 1
			environmentVars['fails'] = 5
			environmentVars['special1'] = 0
			environmentVars['special2'] = 0
			environmentVars['special'] = 0
			es.server.queuecmd('sv_skyname sky_borealis01')
			es.server.queuecmd('bot_join_after_player 1')
			es.server.queuecmd('mp_autoteambalance 0')
			es.server.queuecmd('mp_limitteams 0')
			es.server.queuecmd('bot_difficulty 3')
			es.server.queuecmd('bot_quota_mode fill')
			es.server.queuecmd('mp_humanteam t')
			es.server.queuecmd('mp_roundtime 1')
			es.server.queuecmd('bot_kick all')
	
	class mapSetup:
		def __init__(self):
			pass
		def getMapName(self,ev):
			environmentVars['mapName'] = ev['mapName']
			
		def checkMode(self,ev):
			userid = es.getuserid()
			es.server.queuecmd('es_xfire %d func_buyzone Disable' % userid)
			if 'xp_' in environmentVars['mapName']:
				self.removeHosties()
			else:
				self.enableCompatabilityMode()
		def enableCompatabilityMode(self):
			es.lightstyle(0,'b')
			userid = es.getuserid()
			es.dbgmsg(0,'Enabling Compatability Mode')
			if len(es.createentitylist('func_bomb_target')):
				es.server.queuecmd('es_xfire %d func_bomb_target Disable' %userid)
				es.server.queuecmd('es_xfire %d weapon_c4 Kill' %userid)
            
			elif len(es.createentitylist('func_hostage_rescue')):
				es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
				es.server.queuecmd('es_xfire %d hostage_entity Kill' %userid)
			if len(es.createentitylist('func_bomb_target')):
				es.server.queuecmd('es_xfire %d func_bomb_target Disable' %userid)
				es.server.queuecmd('es_xfire %d weapon_c4 Kill' % userid)
			elif len(es.createentitylist('func_hostage_rescue')):
				es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
				es.server.queuecmd('es_xfire %d hostage_entity Kill' % userid)
			es.msg("#green", "This Server is now running the current map in compatability mode")
		def removeHosties(self):
			userid = es.getuserid()
			if len(es.createentitylist('func_hostage_rescue')):
				es.server.queuecmd('es_xfire %d func_hostage_rescue Disable' %userid)
				es.server.queuecmd('es_xfire %d hostage_entity Kill' %userid)



#es_unload xpints;es_load xpints; changelevel cs_office			
##################################################################################################
#EOF
##################################################################################################